gg_save <- function(plot, filename, ...) {
  temp_dir <- tempdir()
  filename <- fs::path(temp_dir, filename)
  ggplot2::ggsave(filename, plot, width = 7, height = 7, ...)
  filename
}

set.seed(1132)
ilogit <- function(x) 1 / (1 + exp(- x))
out <- mcda(
  benefit("CV", function(x) ilogit(x), weight = .75),
  risk("DVT", function(x) ilogit(- .5 * x), weight = .25),
  br_group(
    label = "PBO",
    CV = rnorm(1e4, .1),
    DVT = rnorm(1e4, .1)
  ),
  br_group(
    label = "TRT",
    CV = rnorm(1e4, 2),
    DVT = rnorm(1e4, 1)
  )
)

test_that("plot", {
  p <- plot(out)
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot.png"))
})

test_that("plot with ref", {
  p <- plot(out, reference = "PBO")
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot-ref.png"))
})

test_that("plot utility", {
  p <- plot_utility(out)
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot-utility.png"))
})

test_that("plot utility with reference", {
  p <- plot_utility(out, reference = "PBO")
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot-utility-ref.png"))
})

test_that("plot utility stacked", {
  p <- plot_utility(out, stacked = TRUE)
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot-utility-stacked.png"))
})

test_that("plot utility stacked with reference", {
  p <- plot_utility(out, reference = "PBO", stacked = TRUE)
  expect_s3_class(p, "ggplot")
  skip_on_cran()
  skip_on_ci()
  expect_snapshot_file(gg_save(p, "plot-utility-stacked-ref.png"))
})

test_that("br runs", {
  res <- br(
    benefit("CV", function(x) x, weight = 0.25),
    risk("DVT", function(x) 1.3 * x, weight = 0.75),
    br_group(
      label = "PBO",
      CV = 1:2,
      DVT = 3:4
    ),
    br_group(
      label = "TRT",
      CV = 5:6,
      DVT = 7:8
    )
  )

  exp_scores <- tibble::tibble(
    CV = c(1, 2, 5, 6),
    DVT = c(3, 4, 7, 8),
    label = c("PBO", "PBO", "TRT", "TRT"),
    iter = rep(1:2, 2)
  ) %>%
    dplyr::mutate(
      CV_weight = 0.25,
      CV_utility = CV,
      CV_score = .25 * CV,
      DVT_weight = 0.75,
      DVT_utility = 1.3 * DVT,
      DVT_score = .75 * 1.3 * DVT,
      total = CV_score + DVT_score
    ) %>%
    dplyr::select(all_of(colnames(res)))
  class(exp_scores) <- c("brisk_br", class(exp_scores))

  exp_summary <- exp_scores %>%
    dplyr::group_by(label) %>%
    dplyr::summarize(
      mean = mean(total),
      `2.50%` = stats::quantile(total, .025, names = FALSE),
      `97.50%` = stats::quantile(total, .975, names = FALSE)
    ) %>%
    dplyr::ungroup()

  expect_equal(res, exp_scores)
})

test_that("stochastic br()", {
  w1 <- c(.2, .933)
  w2 <- c(.1311634, .33331)
  res <- br(
    benefit("CV", function(x) x, weight = w1),
    risk("DVT", function(x) 1.3 * x, weight = w2),
    br_group(
      label = "PBO",
      CV = 1:2,
      DVT = 3:4
    ),
    br_group(
      label = "TRT",
      CV = 5:6,
      DVT = 7:8
    )
  )

  exp_scores <- tibble::tibble(
    CV = c(1, 2, 5, 6),
    DVT = c(3, 4, 7, 8),
    label = c("PBO", "PBO", "TRT", "TRT"),
    iter = rep(1:2, 2)
  ) %>%
    dplyr::mutate(
      CV_weight = rep(w1, 2),
      CV_utility = CV,
      CV_score = w1 * CV,
      DVT_weight = rep(w2, 2),
      DVT_utility = 1.3 * DVT,
      DVT_score = w2 * 1.3 * DVT,
      total = CV_score + DVT_score
    ) %>%
    dplyr::select(all_of(colnames(res)))
  class(exp_scores) <- c("brisk_br", class(exp_scores))

  exp_summary <- exp_scores %>%
    dplyr::group_by(label) %>%
    dplyr::summarize(
      mean = mean(total),
      `2.50%` = stats::quantile(total, .025, names = FALSE),
      `97.50%` = stats::quantile(total, .975, names = FALSE)
    ) %>%
    dplyr::ungroup()

  expect_equal(res, exp_scores)

  expect_error(
    br(
      benefit("CV", function(x) x, weight = 1:3),
      risk("DVT", function(x) 1.3 * x, weight = .25),
      br_group(
        label = "PBO",
        CV = 1:2,
        DVT = 3:4
      ),
      br_group(
        label = "TRT",
        CV = 5:6,
        DVT = 7:8
      )
    ),
    class = "brisk"
  )
})

test_that("br() no extra args", {
  expect_error(
    br(
      benefit("CV", function(x) x, weight = 0.25),
      risk("DVT", function(x) 1.3 * x, weight = 0.75),
      br_group(
        label = "PBO",
        CV = 1:2,
        DVT = 3:4
      ),
      br_group(
        label = "TRT",
        CV = 5:6,
        DVT = 7:8
      ),
      foo = 1
    ),
    class = "brisk"
  )
})

test_that("assertions", {
  expect_error(assert_function(1, "foo"), class = "brisk")
  expect_error(assert_chr(1), class = "brisk")
  expect_error(assert_num("a"), class = "brisk")
  expect_error(
    assert_mcmc(br_group("pbo", CV = 1:5, CVT = 1:4)),
    class = "brisk"
  )
  expect_error(assert_reference(reference = c("a", "b")), class = "brisk")
  expect_error(
    assert_reference(list(scores = list(label = c("a", "b"))), "c"),
    class = "brisk"
  )
  expect_error(assert_p(1.1), class = "brisk")
})

test_that("assert_br, assert_group, & assert_groups", {
  brs <- list(
    benefit("CV", function(x) x, weight = 0.25),
    risk("CV", function(x) 2 * x, weight = 0.75),
    benefit("CVT", function(x) x, weight = 0.25),
    risk("CVT", function(x) 2 * x, weight = 0.75)
  )
  expect_error(assert_brs(brs), class = "brisk")

  brs_good <- list(
    benefit("CV", function(x) x, weight = 0.25),
    risk("CVT", function(x) 2 * x, weight = 0.75)
  )
  groups <- list(
    br_group("pbo", CV = 1:5, CVT = 1:5),
    br_group("trt", CV = 1:4, CVT = 1:4)
  )
  expect_error(assert_groups(groups, brs_good), class = "brisk")
  expect_error(
    assert_group(br_group("pbo", CV = 1:5), brs_good),
    class = "brisk"
  )
  expect_warning(
    assert_group(br_group("pbo", CV = 1:5, CVT = 1:5, DVT = 1:5), brs_good),
    class = "brisk"
  )
})

res <- br(
  benefit("CV", function(x) x, weight = 0.25),
  risk("DVT", function(x) 1.3 * x, weight = 0.75),
  br_group(
    label = "PBO",
    CV = 10:20,
    DVT = 30:40
  ),
  br_group(
    label = "TRT",
    CV = 50:60,
    DVT = 70:80
  )
)

test_that("summary()", {
  exp_summary <- res %>%
    dplyr::group_by(label) %>%
    dplyr::summarize(
      mean = mean(total),
      `2.50%` = stats::quantile(total, .025, names = FALSE),
      `97.50%` = stats::quantile(total, .975, names = FALSE)
    ) %>%
    dplyr::ungroup()
  expect_equal(summary(res), list(summary = exp_summary, scores = res))
  # summary with null probs
  exp_summary2 <- dplyr::select(exp_summary, .data$label, .data$mean)
  expect_equal(
    summary(res, probs = NULL),
    list(summary = exp_summary2, scores = res)
  )
  # with adjustment
  trt <- dplyr::filter(res, .data$label == "TRT") %>% dplyr::pull(.data$total)
  exp_scores_adj <- res %>%
    dplyr::filter(.data$label != "TRT") %>%
    dplyr::mutate(
      total = .data$total - !!trt,
      reference = "TRT"
    )
  exp_summary_adj <- exp_scores_adj %>%
    dplyr::group_by(label) %>%
    dplyr::summarize(
      mean = mean(total),
      `2.50%` = stats::quantile(total, .025, names = FALSE),
      `97.50%` = stats::quantile(total, .975, names = FALSE),
      reference = "TRT"
    ) %>%
    dplyr::ungroup()

  expect_equal(
    summary(res, reference = "TRT"),
    list(summary = exp_summary_adj, scores = exp_scores_adj)
  )
})

test_that("pbrisk() and qbrisk()", {
  res <- br(
    benefit("CV", function(x) x, weight = 0.25),
    risk("DVT", function(x) 1.3 * x, weight = 0.75),
    br_group(
      label = "PBO",
      CV = rnorm(1e4),
      DVT = rnorm(1e4)
    ),
    br_group(
      label = "TRT",
      CV = rnorm(1e4),
      DVT = rnorm(1e4)
    )
  )
  out_q <- qbrisk(res, c(.025, .975))
  out_p <- pbrisk(res, out_q$quantile, direction = "lower")
  dplyr::left_join(out_q, out_p, by = c("label", quantile = "q")) %>%
    dplyr::mutate(equal = p == prob) %>%
    dplyr::pull(.data$equal) %>%
    all() %>%
    expect_true()

  # with adjustment
  out_q <- qbrisk(res, c(.025, .975), reference = "PBO")
  out_p <- pbrisk(res, out_q$quantile, reference = "PBO", direction = "lower")
  dplyr::left_join(out_q, out_p, by = c("label", quantile = "q")) %>%
    dplyr::mutate(equal = p == prob) %>%
    dplyr::pull(.data$equal) %>%
    all() %>%
    expect_true()

  # check direction argument
  out_p_upper <- pbrisk(
    res,
    out_q$quantile,
    reference = "PBO",
    direction = "upper"
  )
  expect_equal(1 - out_p$prob, out_p_upper$prob)
})

test_that("sim_weights works", {
  w <- sim_weights(1e4, a = c(.4, .45), b = c(1, 1), d = c(.2, .5))
  expect_true(all(0.4 <= w[, 1] / w[, 2] & w[, 1] / w[, 2] <= .45))
  expect_true(all(0.2 <= w[, 3] / w[, 2] & w[, 3] / w[, 2] <= .5))
  expect_error(sim_weights(10, a = c(1:3)), class = "brisk")
  expect_error(sim_weights(10, a = c(2, 1)), class = "brisk")
  expect_error(sim_weights(10, a = c(.5, 1)), class = "brisk")
})

test_that("mcda", {
  ilogit <- function(x) 1 / (1 + exp(- x))
  res <- mcda(
    benefit("CV", function(x) ilogit(x), weight = 0.25),
    risk("DVT", function(x) ilogit(1.3 * x), weight = 0.75),
    br_group(
      label = "PBO",
      CV = 1:2,
      DVT = 3:4
    ),
    br_group(
      label = "TRT",
      CV = 5:6,
      DVT = 7:8
    )
  )

  exp_scores <- tibble::tibble(
    CV = c(1, 2, 5, 6),
    DVT = c(3, 4, 7, 8),
    label = c("PBO", "PBO", "TRT", "TRT"),
    iter = rep(1:2, 2)
  ) %>%
    dplyr::mutate(
      CV_weight = 0.25,
      CV_utility = ilogit(CV),
      CV_score = .25 * ilogit(CV),
      DVT_weight = 0.75,
      DVT_utility = ilogit(1.3 * DVT),
      DVT_score = .75 * ilogit(1.3 * DVT),
      total = CV_score + DVT_score
    ) %>%
    dplyr::select(all_of(colnames(res)))
  class(exp_scores) <- c("brisk_mcda", "brisk_br", class(exp_scores))

  expect_equal(res, exp_scores)
})

test_that("mcda checks utility range between 0 and 1", {
  expect_error(
    mcda(
      benefit("CV", function(x) x, weight = 0.25),
      risk("DVT", function(x) 1.3 * x, weight = 0.75),
      br_group(
        label = "PBO",
        CV = 1:2,
        DVT = 3:4
      ),
      br_group(
        label = "TRT",
        CV = 5:6,
        DVT = 7:8
      )
    ),
    class = "brisk"
  )
})

test_that("mcda checks weights sum to 1", {
  expect_error(
    mcda(
      benefit("CV", function(x) x, weight = 0.1),
      risk("DVT", function(x) 1.3 * x, weight = 0.75),
      br_group(
        label = "PBO",
        CV = 1:2,
        DVT = 3:4
      ),
      br_group(
        label = "TRT",
        CV = 5:6,
        DVT = 7:8
      )
    ),
    class = "brisk"
  )
})

test_that("stochastic mcda()", {
  w <- c(.2, .933)
  ilogit <- function(x) 1 / (1 + exp(- x))
  res <- mcda(
    benefit("CV", function(x) ilogit(x), weight = w),
    risk("DVT", function(x) ilogit(1.3 * x), weight = 1 - w),
    br_group(
      label = "PBO",
      CV = 1:2,
      DVT = 3:4
    ),
    br_group(
      label = "TRT",
      CV = 5:6,
      DVT = 7:8
    )
  )

  exp_scores <- tibble::tibble(
    CV = c(1, 2, 5, 6),
    DVT = c(3, 4, 7, 8),
    label = c("PBO", "PBO", "TRT", "TRT"),
    iter = rep(1:2, 2)
  ) %>%
    dplyr::mutate(
      CV_weight = rep(w, 2),
      CV_utility = ilogit(CV),
      CV_score = w * ilogit(CV),
      DVT_weight = rep(1 - w, 2),
      DVT_utility = ilogit(1.3 * DVT),
      DVT_score = (1 - w) * ilogit(1.3 * DVT),
      total = CV_score + DVT_score
    ) %>%
    dplyr::select(all_of(colnames(res)))
  class(exp_scores) <- c("brisk_mcda", "brisk_br", class(exp_scores))

  exp_summary <- exp_scores %>%
    dplyr::group_by(label) %>%
    dplyr::summarize(
      mean = mean(total),
      `2.50%` = stats::quantile(total, .025, names = FALSE),
      `97.50%` = stats::quantile(total, .975, names = FALSE)
    ) %>%
    dplyr::ungroup()

  expect_equal(res, exp_scores)

  expect_error(
    mcda(
      benefit("CV", function(x) ilogit(x), weight = c(.25, .25, .25)),
      risk("DVT", function(x) ilogit(1.3 * x), weight = 0.75),
      br_group(
        label = "PBO",
        CV = 1:2,
        DVT = 3:4
      ),
      br_group(
        label = "TRT",
        CV = 5:6,
        DVT = 7:8
      )
    ),
    class = "brisk"
  )
})
